#ifndef JEZUK_DOM_COMMENT_H
#define JEZUK_DOM_COMMENT_H

////////////////////////////
// C++ DOM definition
//
// $Id: Comment.h,v 1.1.1.1 2002/06/21 11:16:30 jez_higgins Exp $
////////////////////////////

#include <DOM/CharacterData.h>

namespace DOM
{
template<class stringT> class Comment_impl;

template<class stringT>
class Comment : public CharacterData<stringT>
{
  public:
    Comment() : CharacterData<stringT>() { }
    explicit Comment(Comment_impl<stringT>* impl) : CharacterData<stringT>(dynamic_cast<Comment_impl<stringT>*>(impl)) { }
    Comment(const Comment& rhs) : CharacterData<stringT>(rhs) { }
    explicit Comment(const Node<stringT>& rhs) : CharacterData<stringT>(rhs)  
    {
      if(dynamic_cast<Comment_impl<stringT>*>(rhs.impl()) == 0)
        throw std::bad_cast();
    } // Comment
}; // class Comment

////////////////////////////////////////////////////////////////////
template<class stringT>
class Comment_impl : virtual public CharacterData_impl<stringT>
{
  public:
    virtual ~Comment_impl() { }
}; // Comment_impl


} // namespace DOM

#endif
