#ifndef ARABICA_ATTRIBUTE_DEFAULTS_H
#define ARABICA_ATTRIBUTE_DEFAULTS_H
/*
 * $Id: AttributeDefaults.h,v 1.3 2003/09/11 10:26:53 jez_higgins Exp $
 */

#include <SAX/ArabicaConfig.h>
#include <SAX/helpers/StringAdaptor.h>

namespace SAX
{

template<class string_type, class string_adaptor_type = default_string_adaptor<string_type> >
struct AttributeDefaults
{
    typedef string_type stringT;
    typedef string_adaptor_type string_adaptorT;
  
    const stringT required;
    const stringT implied;
    const stringT fixed;

    AttributeDefaults() :
      required(string_adaptorT().makeStringT("#REQUIRED")),
      implied(string_adaptorT().makeStringT("#IMPLIED")),
      fixed(string_adaptorT().makeStringT("#FIXED"))
    {
    } // AttributeDefaults
}; // struct AttributeDefaults

} // namespace SAX

#endif
// end of file
